﻿/* AS3
	Copyright 2008 lhli.net.
	Game of life rules: 23/3
*/
package  {

	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import net.lhli.tools.Debug;
	import Node;
	
	import net.lhli.tools.Stats;
	
	public class Main extends Sprite {
		
		private static const GRID_WIDTH:uint = 86;
		private static const GRID_HEIGHT:uint = 86;
		private static const GRID_NUM:uint = GRID_WIDTH*GRID_HEIGHT;
		public static const NODE_WIDTH:uint = 5;
		
		private static var _instance:Main;
		private var _nodes:Vector.<Node> = new Vector.<Node>();
		private var _nodestate0:Vector.<Boolean> = new Vector.<Boolean>();
		private var _nodestate1:Vector.<Boolean> = new Vector.<Boolean>();
		private var _nodestates:Array = [_nodestate0, _nodestate1];
		private var _currentState:Boolean = false;
		
		private var _isRunning:Boolean = false;
		
		public function Main()
		{
			super();
			
			_instance = this;
			
			stage.showDefaultContextMenu = false;
			
			setupGame();
						
			go.addEventListener(MouseEvent.CLICK, handleGoClick);
			clear.addEventListener(MouseEvent.CLICK, handleClearClick);
			printIt.addEventListener(MouseEvent.CLICK, handleTraceClick);

			//addChild( new Stats() );

		}
		
		public static function setNodeState(node:Node):void
		{			
			_instance._nodestates[uint(!_instance._currentState)][node.id] = node.state;
		};
		
		private function setupGame():void
		{
			var i:int = 0;
			var ii:int;
			var c:int;
			for (i; i < GRID_WIDTH; i++)
			{
				ii = 0;
				for (ii; ii < GRID_HEIGHT; ii++)
				{
					var thisNode:int = (i*GRID_HEIGHT)+ii;
					
					_nodes[thisNode] = new Node();				
					_nodes[thisNode].x = i * NODE_WIDTH;
					_nodes[thisNode].y = ii * NODE_WIDTH;

					_nodes[thisNode].state = Patterns.PATTERN[c];
					_nodes[thisNode].id = thisNode;

					_nodestate0[thisNode] = Patterns.PATTERN[c];
					_nodestate1[thisNode] = Patterns.PATTERN[c];

					addChild(_nodes[thisNode]);
					
					c++;
				}
			}
		};
		
		private function handleGoClick(event:Event):void
		{
			if (_isRunning){
				stopGame();
			} else {
				startGame();
			}
		};
		
		private function handleTraceClick(event:Event):void
		{
			var i:int = 0;
			for (i; i < _nodes.length; i++) {
				trace(_nodes[i].state + ',');
			}
		};
		
		private function handleClearClick(event:Event):void
		{
			stopGame();
			var i:int = 0;
			for (i; i < _nodes.length; i++) {
				_nodes[i].state = false;
				_nodestate0[i] = false;
				_nodestate1[i] = false;
			}
		};
		
		private function startGame():void
		{
			_isRunning = !_isRunning;
			go.label = 'Stoppa';
			addEventListener(Event.ENTER_FRAME, runGame);
		};
		
		private function stopGame():void
		{
			_isRunning = !_isRunning;
			go.label = 'Starta';
			removeEventListener(Event.ENTER_FRAME, runGame);
		};
		
		private function runGame(event:Event):void
		{
			var currentState:Vector.<Boolean> = _nodestates[uint(_currentState)];
			var prevState:Vector.<Boolean> = _nodestates[uint(!_currentState)];
			
			var i:int = 0;
			var ii:int;
			var c:int;
			var tc:int = 0;
			
			var xMinus1:int;
			var xPlus1:int;
			var yMinus1:int;
			var yPlus1:int;
			var thisNode:int;
			
			for (i; i < GRID_WIDTH; i++)
			{
				ii = 0;
				for (ii; ii < GRID_HEIGHT; ii++)
				{
					// get no of live neighbours
					xMinus1 = (i-1+GRID_WIDTH) % GRID_WIDTH;
					xPlus1 = (i+1) % GRID_WIDTH;
					yMinus1 = (ii-1+GRID_HEIGHT) % GRID_HEIGHT;
					yPlus1 = (ii+1) % GRID_HEIGHT;
										
					c = prevState[(xMinus1*GRID_HEIGHT)+yMinus1]+
						prevState[(xMinus1*GRID_HEIGHT)+ii]+
						prevState[(xMinus1*GRID_HEIGHT)+yPlus1]+
						prevState[(i*GRID_HEIGHT)+yMinus1]+
						prevState[(i*GRID_HEIGHT)+yPlus1]+
						prevState[(xPlus1*GRID_HEIGHT)+yMinus1]+
						prevState[(xPlus1*GRID_HEIGHT)+ii]+
						prevState[(xPlus1*GRID_HEIGHT)+yPlus1];

					// set to alive or dead
					// rules: 23/3
					thisNode = (i*GRID_HEIGHT)+ii;
					
					if (prevState[thisNode] && (c == 2 || c == 3)){// stay alive
						currentState[thisNode] = true;
						tc++;
					} else if (c == 3){ 						// spawn
						currentState[thisNode] = true;
						tc++;
	 				} else {									// stay dead
						currentState[thisNode] = false; 
					}

					// draw results
					_nodes[thisNode].state = currentState[thisNode];
				}
			}
			if (tc == 0) stopGame();
			_currentState = !_currentState;
		};
		
	}	
}
